#include "DISP7SEG.h"
#define ANALIZE_PIN A0
#define VCCCHECK_PIN A1
#define MODESEL 8

DISP7SEG disp ;
int mode ;

// ----------------------
// ----- セットアップ -----
// ----------------------
void setup() {
  Wire.begin();
  disp.init() ;
  mode = 0 ;

  pinMode(ANALIZE_PIN, INPUT);
  pinMode(VCCCHECK_PIN, INPUT);
  pinMode(MODESEL, INPUT);

  Serial.begin(9600);
}

void loop() {
  // ----- 抵抗値算出 -----
  mode = (digitalRead(MODESEL) == HIGH) ? 0 : 1 ;
  int vccData = analogRead(VCCCHECK_PIN) ;
  int readData = analogRead(ANALIZE_PIN) ;
  int r = 0 ;
  if ( mode == 0) {
    r = (vccData - readData) * (1000.0 / readData) ;
  } else {
    r = (vccData - readData) * (10000.0 / readData) ;
  }
  Serial.print(" vcc=") ; Serial.print(vccData) ;
  Serial.print("  data=") ; Serial.print(readData) ;
  Serial.print("     r=") ; Serial.println(r) ;

  // ----- 表示用数値に変換 -----
  int n1 = 12 ;
  int n2 = 12 ;
  int n3 = 12 ;
  int n4 = 12 ;
  int range = 0 ;
  if (r > 0) {
    if (r < 1000) {
      n1 = r / 1000 ;
      n2 = (r % 1000) / 100 ;
      n3 = (r % 100) / 10 ;
      n4 = r % 10 ;
      if (n1 == 0) { n1 = 416 ; }
      if (n1 == 0 && n2 == 0) { n2 = 416 ; }
      if (n1 == 0 && n2 == 0 && n3 == 0) { n3 = 416 ; }
    } else {
      range = 1 ;
      n1 = r / 10000 ;
      n2 = (r % 10000) / 1000 ;
      n3 = 10 ;
      n4 = (r % 1000) / 100 ;
      if (n1 == 0) { n1 = 416 ; }
    }
  }

  // ----- 表示 -----
  // --- MODE
  disp.disp7SEG(4,0,13) ;
  if (mode == 0) {
    disp.dispFont16( 0,4,' ') ;
    disp.dispFont16( 8,4,'1') ;
  } else {
    disp.dispFont16( 0,4,'1') ;
    disp.dispFont16( 8,4,'0') ;
  }
  disp.dispFont16(16,4,'K') ;

  // --- 抵抗値表示
  disp.disp7SEG(28,0,n1) ;
  disp.disp7SEG(44,0,n2) ;
  disp.disp7SEG(60,0,n3) ;
  disp.disp7SEG(76,0,n4) ;

  // --- 単位表示
  if (range == 0) {
    disp.disp7SEG(100,4,14) ;
    disp.disp7SEG(113,4,214) ;
  } else {
    disp.dispFont16(100,4,'K') ;
    disp.disp7SEG(108,4,14) ;
  }

  // ----- 計測間隔
  delay(1000) ;
}
